import { tableColumnInGroup } from '../components/ColumnSet/index.vue'
import type { KeyType } from '../components/ColumnSet/index.vue'
import { Ref } from 'vue'
import { Column } from 'element-plus'

export default function useTableColumnSet(
  tableColumns: Ref<tableColumnInGroup[] | Column[]>
) {
  const filterColumnKeys = ref<KeyType[]>([])
  const filteredColumns = computed(() =>
    tableColumns.value.filter(({ dataKey }) =>
      filterColumnKeys.value.includes(dataKey as KeyType)
    )
  )
  const columnChecked = (checkedColumnKeys: string[]) => {
    filterColumnKeys.value = checkedColumnKeys
  }
  return {
    columnChecked,
    filteredColumns,
  }
}
